package com.mycompany.converterbug;

import junit.framework.TestCase;

import javax.persistence.*;

/**
 * Test the converterbug.
 */
public class ConverterBugTestcase extends TestCase {
    EntityManagerFactory emf;

    @Override
    protected void setUp() throws Exception {
        super.setUp();
        try {
            emf = Persistence.createEntityManagerFactory("test");
        } catch (Exception e){
           System.out.println("Got Exception");
           e.printStackTrace();
           throw e;
        }
    }

    @Override
    protected void tearDown() throws Exception {
        emf.close();
        super.tearDown();
    }

    public void testConverterBug() {
        int id = 0;
        {
            EntityManager em = emf.createEntityManager();

            EntityTransaction transaction = em.getTransaction();
            transaction.begin();

            Data x = new Data();
            // On Oracle Database we could also set field to "" as Oracle
            // Stores null on empty strings.
            // But the testcase is using H2.
            x.setField(null);
            em.persist(x);
            transaction.commit();
            id = x.getId();
            em.close();
        }

        {
            // Retrieve it again
            EntityManager em = emf.createEntityManager();
            EntityTransaction transaction = em.getTransaction();
            transaction.begin();

            Data y = em.find(Data.class, id);
            assertEquals("The converter inside Data shall convert null to an empty string", "", y.getField());
            em.close();
        }
    }
}
