package com.mycompany.converterbug;

import javax.persistence.AttributeConverter;
import javax.persistence.Converter;

/**
 * An attribute converter which circumvents the problem, that empty strings
 * are stored as null in an oracle database.
 *
 * This converter only works upon deserialization.
 */
@Converter
public final class NotNullStringConverter implements AttributeConverter<String, String> {

    @Override
    public String convertToDatabaseColumn(String attribute) {
        if (attribute == null) {
            System.out.println("Attempting to convert an <null> String. Reverse converted string will be empty");
        }
        return attribute;
    }

    @Override
    public String convertToEntityAttribute(String dbData) {
        if (dbData == null){
            System.out.println ("Converting null to empty string");
            return "";
        } else {
            return dbData;
        }
    }
}
